unit Desc1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Spin, Inifiles;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    Image1: TImage;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    Label1: TLabel;
    Edit2: TEdit;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure SpinEdit1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;
  IniFile1 : TIniFile;
  Change : Boolean;

implementation

{$R *.DFM}
{ Declaration du bus I2C - DLL Borland C }
function I2C_Address(address : LongInt) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Start : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Stop : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Send(nb:LongInt; data : pointer ) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Read(nb:LongInt; data : pointer ) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Init : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Info : LongInt; stdcall; external 'I2C_Drv32.dll';


procedure TForm1.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var
add : integer;
txtsec : string;
txtnom : string;
txtdesc : string;
txtmode : string;
accmode : integer;

begin
if SpinEdit1.Value <> 0 then
  begin
  txtsec := 'Circuit ' + IntToHex(SpinEdit1.Value, 2);
  txtnom := IniFile1.ReadString(txtsec, 'Nom', '');
  txtdesc := IniFile1.ReadString(txtsec, 'Desc', '');
  txtmode := IniFile1.ReadString(txtsec, 'Mode', '1');
  Edit1.Text := txtnom;
  Edit2.Text := txtdesc;
  Button2.Enabled := True;
  Button3.Enabled := True;
  Edit1.Enabled := True;
  Edit2.Enabled := True;
  if txtmode = '1' then RadioButton1.Checked := True;
  if txtmode = '2' then RadioButton2.Checked := True;
  if txtmode = '3' then RadioButton3.Checked := True;
  end
else
  begin
  Edit1.Text := 'ALL';
  Edit2.Text := 'General Call';
  Button2.Enabled := False;
  Button3.Enabled := False;
  Edit1.Enabled := False;
  Edit2.Enabled := False;
  end;
Change := False;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
IniFile1 := TIniFile.Create('I2C.INI');
Edit1.Text := 'ALL';
Edit2.Text := 'General Call';
Change := False;
I2C_Init;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
IniFile1.Free;
end;


procedure TForm1.Button2Click(Sender: TObject);
var
txtsec : string;
txtnom : string;
txtdesc : string;
txtmode : string;
accmode : integer;
i : integer;

begin
txtnom := Edit1.Text;
txtdesc := Edit2.Text;
txtsec := 'Circuit ' + IntToHex(SpinEdit1.Value, 2);
if txtnom = '' then
  begin
  i := MessageDlg( 'Effacer l''entre du circuit ?',
    mtWarning, [mbYes, mbNO], 0);
  if i = mryes then
    begin
    Edit2.Text := '';
    IniFile1.EraseSection(txtsec);
    Change := False;
    end;
  end
else
  begin
  IniFile1.WriteString(txtsec, 'Nom', txtnom);
  IniFile1.WriteString(txtsec, 'Desc', txtdesc);
  if RadioButton1.Checked = True then accmode := 1;
  if RadioButton2.Checked = True then accmode := 2;
  if RadioButton3.Checked = True then accmode := 3;
  txtmode := IntToStr(accmode);
  IniFile1.WriteString(txtsec, 'Mode', txtmode);
  Change := False;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i : integer;
  add : Integer;
  hadd : string;
begin
i := I2C_Start;
add := SpinEdit1.Value;
{ Fait la correction pour les circuits en read only }
if RadioButton2.Checked = True then add := add +1;
i := I2C_Address(add);
I2C_Stop;
hadd := IntToHex(SpinEdit1.Value, 2);
if i = 0 then
  MessageDlg( 'Le circuit 0x'+hadd+' est prsent.',
    mtInformation, [mbOK], 0)
else
  MessageDlg( 'Pas de rponse du circuit 0x'+hadd+' !',
    mtWarning, [mbOK], 0);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
Change := True;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
Change := True;
end;

procedure TForm1.SpinEdit1Click(Sender: TObject);
var
  add : integer;

begin
if Change = True then
  begin
  add := MessageDlg( 'Enregistrer les modifications ?',
           mtConfirmation, [mbYes, mbNo], 0);
  if add = mrYes then
    Button2.Click;
  Change := False;
  end;

end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
Change := True;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
Change := True;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
Change := True;
end;

end.
