// Exemple : Adressage d'un PCF8574 sur le bus I2C
// (c) Marc BOUGET - 1998

unit pcf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button1: TButton;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GroupBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  add : array[1..32] of integer;
  value : byte;
  nb_cir : integer;
  add_cur : integer;

implementation

{$R *.DFM}
{ Declaration du bus I2C - DLL Borland C }
function I2C_Address(address : LongInt) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Start : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Stop : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Send(nb:LongInt; data : pointer ) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Read(nb:LongInt; data : pointer ) : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Init : LongInt; stdcall; external 'I2C_Drv32.dll';
function I2C_Info : LongInt; stdcall; external 'I2C_Drv32.dll';

// Bouton Quitter
procedure TForm1.Button1Click(Sender: TObject);
begin
Application.Terminate;
end;

// Cration de la fenetre, on recherche les PCF8574 prsents
procedure TForm1.FormCreate(Sender: TObject);
var
 i : integer;
 txt : string;
begin
I2C_Init;     // La premiere chose a faire !
i := 64;      // adresse de base d'un PCF8574 (0x4x)
nb_cir := 0;
repeat        // Scan le Bus I2C pour trouver les PCF8574
    I2C_Start;
    If I2C_Address(i) = 0 then         // on en a un ?
       Begin                           // oui alors
       add[nb_cir+1] := i;             // memorise son adresse
       nb_cir := nb_cir + 1;           // comptabilise le nombre de circuit
       txt := IntToHex(i, 2);          // convertion en texte hexa
       ComboBox1.Items.Add(txt);       // ajoute dans la combobox
       end;
    I2C_Stop;
    i := i + 2;
until (i > 78);
i := 112;     // adresse de base d'un PCF8574A (0x7x)
repeat        // Scan le Bus I2C pour trouver les PCF8574A
    I2C_Start;
    If I2C_Address(i) = 0 then         // on en a un ?
       Begin                           // oui alors
       add[nb_cir+1] := i;             // memorise son adresse
       nb_cir := nb_cir + 1;           // comptabilise le nombre de circuit
       txt := IntToHex(i, 2);          // convertion en texte hexa
       ComboBox1.Items.Add(txt);       // ajoute dans la combobox
       end;
    I2C_Stop;
    i := i + 2;
until (i > 126);
ComboBox1.ItemIndex := 0;           // Selectionne par defaut le premier trouve
add_cur := 1;                       // memorise la slection
GroupBox1Click(Sender);             // envoie la valeur par dfaut
end;


// Emet la nouvelle valeur suite a changement
procedure TForm1.GroupBox1Click(Sender: TObject);
begin
Value := 0;
if CheckBox1.Checked = True then Value := Value + 1;
if CheckBox2.Checked = True then Value := Value + 2;
if CheckBox3.Checked = True then Value := Value + 4;
if CheckBox4.Checked = True then Value := Value + 8;
if CheckBox5.Checked = True then Value := Value + 16;
if CheckBox6.Checked = True then Value := Value + 32;
if CheckBox7.Checked = True then Value := Value + 64;
if CheckBox8.Checked = True then Value := Value + 128;
I2C_Start;
I2C_Address(add[add_cur]);
I2C_Send(1, @Value);
I2C_Stop;

end;

// Prend en compte la nouvelle adresse
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
add_cur := ComboBox1.ItemIndex +1;
GroupBox1Click(Sender);        // rmet la valeur des LED
end;

end.
